/*jslint node: true */
/*global define */

define(['angular', 'app'], function (angular, app) {
    "use strict";
    app.constant("config", {
        app: {
            title: 'Angular Boilerplate',
            pages: ['Home']
        },
        formats: {
            FRONTEND: {
                DATE: 'MM/dd/yyyy',
                TIME: 'hh:mm a',
                DATE_TIME: 'MM/dd/yyyy hh:mm a'
            },
            BACKEND: {
                DATE: 'MM/dd/yyyy',
                TIME: 'HH:mm ss',
                DATE_TIME: 'MM/dd/yyyy HH:mm:ss'
            }
        },
        defaults: {
            DATE_RANGE_DELTA: {days: 30}
        }
    });

    app.config(function ($logProvider, $provide) {
        $logProvider.debugEnabled(true);
        $provide.decorator('$log', ['$delegate', function ($delegate) {
            $delegate.table = angular.noop;
            $delegate.info = angular.noop;
            $delegate.warn = angular.noop;
            $delegate.error = angular.noop;
            return $delegate;
        }]);
    });
});
