/*jshint unused: vars */
require.config({
	paths: {

		/*                  LIBRARIES                    */
		'angular'						: '../libs/angular/js/angular',
		'angularAnimate'				: '../libs/angular-animate/js/angular-animate',
		'angularBusy'					: '../libs/angular-busy/js/angular-busy',
		'angularSanitize'				: '../libs/angular-sanitize/js/angular-sanitize',
		'angularSnap'					: '../libs/angular-snap/js/angular-snap',
		'angularTouch'					: '../libs/angular-touch/js/angular-touch',
		'angularUiBootstrap'			: '../libs/angular-bootstrap/js/ui-bootstrap-tpls',
		'angularUiBootstrapOverwrites'	: '../libs/angular-bootstrap/js/ui-bootstrap-overwrites',
		'angularUiRouter'				: '../libs/angular-ui-router/js/angular-ui-router',
		'angularUiUtils'				: '../libs/angular-ui-utils/js/ui-utils',
		'jQuery'						: '../libs/jquery/js/jquery',
		'lodash'						: '../libs/lodash/js/lodash',
		'snap'							: '../libs/snap/js/snap',
		'text'							: '../libs/requirejs-text/text',

		/*                  DECORATORS                    */
		'ngMaskDecoration'				: 'decorations/ui-mask_decorator',
		'uiCollapseDecoration'			: 'decorations/ui-collapse_decorator',
		'ngClickDecoration'				: 'decorations/ng-click_decorator',

		/*                  APPLICATION                    */
		'appConfig'						: 'app-config',
		'app'							: 'app',
		'router'						: 'router',

		//templates is generated by grunt ngtemplate task
		'templates'						: 'templates',


		/*                  CONTAINER                    */
		'MainController'				: 'container/main/main_controller',

		'HeaderController'				: 'container/components/header/header_controller',
		'TwoPanelController'			: 'container/components/content/two-column_controller',
		'List'							: 'container/components/content/list/list_directive',
		'Menu'							: 'container/components/menu/menu_directive',
		'SecondaryNavigationController' : 'container/components/content/secondary-navigation/secondary-navigation_controller',
		'FooterController'				: 'container/components/footer/footer_controller',

		/*                  FEATURE SECTIONS                    */

		// Home
		'HomeModule'					: 'modules/home/home_module',
		'HomeController'				: 'modules/home/pages/home_controller',

		 // Sample Left-Hand Nav Feature
		'CPAAModule'					: 'modules/cpaa/cpaa_module',
		'Constants'						: 'modules/cpaa/core/constants',
		'AssessmentService'				: 'modules/cpaa/core/assessment_service',
		'AssessmentInstanceBuilder'		: 'modules/cpaa/core/assessment-instance-builder',
		'RecommendationEngine'			: 'modules/cpaa/core/recommendation-engine',
		'CPAAPrimaryWrapperController'	: 'modules/cpaa/components/primary-wrapper/cpaa-primary-wrapper_controller',
		'AssessmentController'			: 'modules/cpaa/pages/assessment/assessment_controller',
		'RecommendationsController'		: 'modules/cpaa/pages/recommendations/recommendations_controller',
		'AlgorithmsController'			: 'modules/cpaa/pages/algorithms/algorithms_controller',

		'SASTModule'					: 'modules/sast/sast_module',
        'SASTConstants'					: 'modules/sast/core/constants',
        'SASTAssessmentService'         : 'modules/sast/core/sast_assessment_service',
        'SASTRecommendationEngine'      : 'modules/sast/core/sast_recommendation_engine',
        'SASTPrimaryWrapperController'  : 'modules/sast/components/primary-wrapper/sast_primary_wrapper_controller',
        'SASTAssessmentController'      : 'modules/sast/pages/assessment/sast_assessment_controller',
        'SASTRecommendationsController' : 'modules/sast/pages/recommendations/sast_recommendations_controller',
        'ScoringInfoController'         : 'ui-components/modals/scoring-info/scoring-info_controller',
        'scoringInfoService'            : 'ui-components/modals/scoring-info/scoring-info_service',

        'NAONModule'					: 'modules/naon/naon_module',
        'NAONController'				: 'modules/naon/pages/naon_controller',

        'AORNModule'					: 'modules/aorn/aorn_module',
        'AORNController'				: 'modules/aorn/pages/aorn_controller',

        /*                  CORE COMPONENTS                    */
		'delayManager'					: 'core/connection/delay_factory',

		'EulaController'				: 'core/eula/eula_controller',
		'eula_service'					: 'core/eula/eula_service',

        'ResourcesModule'               : 'modules/resources/resources_module',
		'ResourcesController'			: 'modules/resources/pages/resources_controller',
        'ResourcesConstants'            : 'modules/resources/core/resources_constants',

		'global'						: 'core/services/global',
		'formatter'						: 'core/services/formatter',
		'unsavedChanges'				: 'core/services/unsaved_changes',
		'focusManager'					: 'core/services/focus_directive',
        'doCompile'					    : 'core/services/compile_directive',

		/*					UI-COMPONENTS             */
		'EntryForm'						: 'ui-components/form/entry-form/entry-form_directive',
		'FormControlWrapper'			: 'ui-components/form/controls/core/form-control-wrapper/form-control-wrapper_directive',

		'iOSKeyboard'					: 'ui-components/form/controls/core/iOS-keyboard/iOS-keyboard_directive',

		'InputRange'					: 'ui-components/form/controls/simple/input-range/input-range_directive',
		'InputSelect'					: 'ui-components/form/controls/simple/input-select/input-select_directive',
		'InputText'						: 'ui-components/form/controls/simple/input-text/input-text_directive',
		'InputFile'						: 'ui-components/form/controls/simple/input-file/input-file_directive',
		'InputNumber'					: 'ui-components/form/controls/simple/input-number/input-number_directive',
		'InputPhone'					: 'ui-components/form/controls/simple/input-phone/input-phone_directive',
		'InputGroupCheckbox'			: 'ui-components/form/controls/simple/input-group-checkbox/input-group-checkbox_directive',
		'InputGroupRadio'				: 'ui-components/form/controls/simple/input-group-radio/input-group-radio_directive',

		'DateControls'					: 'ui-components/form/controls/composite/input-date-picker/date-controls_directive',
		'TimeControls'					: 'ui-components/form/controls/composite/input-time-picker/time-controls_directive',
		'InputDateTime'					: 'ui-components/form/controls/composite/input-date-time/input-date-time_directive',

		'UserInputPattern'				: 'ui-components/form/validation/user-input-pattern/user-input-pattern_directive',
		'ValidationSummary'				: 'ui-components/form/validation/validation-summary/validation-summary',
		'ErrorHandling'					: 'ui-components/form/validation/validation-summary/error-handling_directive',
		'RequiredField'					: 'ui-components/form/validation/required-field-indicator/required-field-indicator_directive',

		'modalService'					: 'ui-components/modals/helper/modal_service',
		'HelpController'				: 'ui-components/modals/help/help_controller',
		'AboutController'				: 'ui-components/modals/about/about_controller',
        'ClearController'				: 'ui-components/modals/clearData/clear_data_controller',

		'NavBar'						: 'ui-components/nav-bar/nav-bar_directive',
		'FilterButton'					: 'ui-components/filter-button/filter-button_directive',
		'FilterWrapper'					: 'ui-components/filter/filter-wrapper_directive',

		'DataTableDirective'			: 'ui-components/table/table_directive',

		'AriaHidden'					: 'ui-components/accessibility/aria-hidden/aria-hidden_directive',
		'aDirecitve'					: 'ui-components/html-extensions/a_directive',
		'iDirecitve'					: 'ui-components/html-extensions/i_directive',
		'BackButton'					: 'ui-components/back-button/back-button_directive',
		'disableNgAnimate'				: 'ui-components/disable-ng-animate/disable-ng-animate_directive',

		// ACCESSIBLE DIRECTIVES
		'AccessibleAccordion'			: 'ui-components/accordion/accessibleaccordion_directive',
		'accessibleCarousel'			: 'ui-components/carousel/accessible-carousel_directive',
		'AccessibleCarouselController'	: 'ui-components/carousel/accessible-carousel_controller',
		'accessibleDatePickerServices'	: 'ui-components/form/controls/simple/accessibledatepicker/accessibledatepicker_directive',
		'accessibleTimePickerServices'	: 'ui-components/form/controls/simple/accessibletimepicker/accessibletimepicker_directive'
	},
	shim: {
		'angular'					: {deps: ['jQuery'], 'exports': 'angular'},
		'jQuery'					: {'exports': '$'},
		'lodash'					: {'exports': '_'},
		'angularSanitize'			: ['angular'],
		'angularUiUtils'			: ['angular'],
		'angularUiRouter'			: ['angular'],
		'angularUiBootstrap'		: ['angular'],
		'angularUiBootstrapOverwrites'		: ['angularUiBootstrap'],
		'angularTouch'				: ['angular'],
		'angularBusy'				: ['angular'],
		'angularSnap'				: ['angular', 'snap'],
		'angularAnimate'			: ['angular'],
		'templates'					: ['app']
	},
	priority: ['angular']
});

require(
	[
		'app',
		'angular',
		'angularTouch',
		'angularUiUtils',
		'angularUiRouter',
		'angularSanitize',
		'angularAnimate',
		'angularBusy',
		'AriaHidden',
		'AccessibleAccordion',
		'accessibleCarousel',
		'AccessibleCarouselController',
		'aDirecitve',
		'angularUiBootstrap',
		'angularUiBootstrapOverwrites',
		'appConfig',
		'BackButton',
		'DataTableDirective',
		'delayManager',
		'disableNgAnimate',
		'EntryForm',
		'ErrorHandling',
		'FilterButton',
		'FilterWrapper',
		'focusManager',
		'formatter',
		'FormControlWrapper',
		'global',
		'iDirecitve',
		'InputDateTime',
		'InputFile',
		'InputGroupCheckbox',
		'InputGroupRadio',
		'InputNumber',
		'InputPhone',
		'InputRange',
		'InputSelect',
		'InputText',
		'iOSKeyboard',
		'List',
		'lodash',
		'Menu',
		'NavBar',
		'ngClickDecoration',
		'ngMaskDecoration',
		'RequiredField',
		'ResourcesController',
		'router',
		'templates',
		'TwoPanelController',
		'uiCollapseDecoration',
		'unsavedChanges',
		'UserInputPattern',
		'ValidationSummary',
	], function (app, angular) {
		'use strict';

		angular.element().ready(function () {
			angular.bootstrap(document, [app.name]);
		});
	});