/*jslint node: true */
/*global define, describe, beforeEach, inject, it, expect */

define(['CPAAPrimaryWrapperController'], function () {
    'use strict';

    describe("The CPAAPrimaryWrapperController controller", function () {
        var controller,
            modalMock,
            modalMockController,
            modalServiceMock,
            modalInstance,
            rootScope,
            scope,
            state,
            toParamsMock,
            stateParamsMock,
            fakeModal;

        toParamsMock = {
            data: {
                panel: "secondary",
                primaryHeader: "Task List",
                appletName: "Comprehensive Patient Assessment & Algorithms",
                headerTitle: "Safe Patient Handling",
                baseStateName: 'main.two-panel.secondary-navigation.cpaa',
                initialState: "assessment",
                paramSections: [
                    {
                        paramValue: "multi-tasks",
                        section: "multi-tasks",
                        buttonClass: "option1",
                        sectionName: "Conduct an assessment for multiple tasks",
                        sectionIndex: 1,
                        algorithms: []
                    },
                    {
                        paramValue: "single-task",
                        section: "single-task",
                        buttonClass: "option2",
                        sectionName: "Select a Single Task",
                        sectionIndex: 2,
                        algorithms: []
                    }
                ],
                algorithms: []
            }
        };

        stateParamsMock = {
            algorithms: ['1', '2', '10'],
            nowDoAssessment: "no",
            section: "multi-tasks"
        };

        fakeModal = {
            result: {
                then: function(confirmCallback, cancelCallback) {
                    //Store the callbacks for later when the user clicks on the OK or Cancel button of the dialog
                    this.confirmCallBack = confirmCallback;
                    this.cancelCallback = cancelCallback;
                }
            },
            close: function( item ) {
                //The user clicked OK on the modal dialog, call the stored confirm callback with the selected item
                this.result.confirmCallBack( item );
            },
            dismiss: function( type ) {
                //The user clicked cancel on the modal dialog, call the stored cancel callback
                this.result.cancelCallback( type );
            }
        };


        beforeEach(function () {
            module('angularTemplateApp');

            //  module(function ($provide) {
            //      $provide.value('toParams', toParamsMock);
            //      $provide.value('toState', toParamsMock);
            //      $provide.value('$stateParams', stateParamsMock);
            //      $provide.value('$modal', modalMock);
            //  });

            inject(function ($controller, $rootScope, $state) {
                rootScope = $rootScope;
                scope = $rootScope.$new();
                state = $state;
                modalMock = jasmine.createSpyObj('modal', ['open', 'close']);
                modalServiceMock = jasmine.createSpyObj('modalService', ['showModal']);
                controller = $controller('CPAAPrimaryWrapperController', {
                    $scope: scope,
                    toState: toParamsMock,
                    toParams: toParamsMock,
                    $modal: modalMock,
                    modalService: modalServiceMock
                });
            });
        });

        // TODO: @JASON fix this, broken with modal updates to info.
        //it("should open a modal when using the info button", function () {
        //    scope.infoButton();
        //    expect(modalMock.open).toHaveBeenCalled();
        //    //  expect(modalInstance.close).toHaveBeenCalledWith(true);
        //    //  expect(scope.infoButton).toBeDefined();
        //    //  expect(modalInstance).toHaveBeenCalled();
        //});

        //  it("should load", function () {
        //      scope.state.transitionTo('main.two-panel.secondary-navigation.cpaa', toParamsMock);
        //      scope.$apply();
        //      expect(scope.sectionName).toEqual('$stateChangeSuccess');
        //  });
    });
});