//      /*jslint node: true, unparam: true */
//      /*global define, describe, beforeEach, inject, it, expect */
//
//      define(['AlgorithmsController'], function () {
//          'use strict';
//
//          describe("The AlgorithmsController controller", function () {
//              var createController,
//                  scope,
//                  httpBackend,
//                  stateParams,
//                  ConstantsMock,
//                  AssessmentInstanceBuilderMock,
//                  RecommendationEngineMock,
//                  stateParamsMock,
//                  windowMock;
//
//
//              // Will have a unit test just on teh Assessment Service.
//              // This just mocks up the functions so it returns what we want.
//              ConstantsMock = {
//                  questions: [
//                      {
//                          id: 7,
//                          question: 'Is the patient greater than 300 lb or 136 kg?',
//                          options: ['Yes', 'No']
//                      },
//                      {
//                          id: 2,
//                          question: 'Weight Bearing Capability',
//                          options: ['Fully Weight Bearing', 'Non-Weight Bearing', 'Partial Weight Bearing']
//                      },
//                      {
//
//                          id: 10,
//                          question: 'Balance',
//                          options: ['Ability to maintain sitting balance at edge of bed/chair', 'Ability to maintain standing balance', 'No sitting or standing balance']
//                      }
//                  ],
//                  algorithms: [{
//                      id: 2,
//                      name: 'Lateral Transfer to/from Supine Positions: Bed, Stretcher, Trolley, Procedure Table',
//                      flowChart: 'path/to/chart/image.png',
//                      notes: 'yes test common recommendation',
//                      questions: [1, 4],
//                      algorithm: [
//                          {
//                              id: [1],
//                              answerCriteria: '/^1B$/',
//                              recommendation: 0
//                          }, {
//                              id: [1, 4],
//                              answerCriteria: '/^1A4B$/',
//                              recommendation: 0
//                          }, {
//                              id: [1, 4],
//                              answerCriteria: '/^1A4A$/',
//                              recommendation: 1
//                          }
//                      ],
//                      solution: [
//                          {
//                              recommendation: 'A Recommendation'
//                          }, {
//                              recommendation: 'B Recommendation'
//                          }
//                      ]
//                  }]
//              };
//              AssessmentInstanceBuilderMock = {
//                  getInstance: function () {
//                      return {
//                          returnAllQuestions: function () {
//                              return ConstantsMock.questions;
//                          },
//                          returnSpecificAlgorithmQuestions: function () {
//                              return ConstantsMock.algorithms;
//                          },
//                          returnAllQuestionsWithAnswers: function () {
//                              return ConstantsMock.questions;
//                          }
//                      };
//                  }
//              };
//              RecommendationEngineMock = {
//                  recommend: function () {
//                      return ConstantsMock.algorithms[0].solution[0].recommendation;
//                  },
//                  getAlgorithmOptions: function () {
//                      return ConstantsMock.questions;
//                  },
//                  getSelectedAlgorithms: function () {
//                      return ConstantsMock.questions[0];
//                  },
//                  saveSelectedAlgorithms: function (algorithmSaved) {
//                      return algorithmSaved;
//                  },
//                  clearSelectedAlgorithms: function () {
//                      return true;
//                  },
//                  getChosenAlgorithms: function () {
//                      return ConstantsMock.questions[0];
//                  },
//                  saveChosenAlgorithms: function (algorithmSaved) {
//                      return algorithmSaved;
//                  },
//                  clearChosenAlgorithms: function () {
//                      return true;
//                  }
//              };
//              stateParamsMock = {
//                  algorithms: [],
//                  section: "single-task",
//                  nowDoAssessment: 'no'
//              };
//
//              beforeEach(function () {
//                  module('angularTemplateApp');
//
//                  module(function ($provide) {
//                      $provide.value('AssessmentInstanceBuilder', AssessmentInstanceBuilderMock);
//                      $provide.value('RecommendationEngine', RecommendationEngineMock);
//                      $provide.value('Constants', ConstantsMock);
//                      $provide.service('$window', function () {
//                          windowMock = jasmine.createSpyObj('$window', ['open']);
//                          return windowMock;
//                      });
//                  });
//
//                  inject(function ($controller, $rootScope, _$httpBackend_, $state, _$window_) {
//                      spyOn($state, 'go');
//                      scope = $rootScope.$new();
//                      httpBackend = _$httpBackend_;
//                      stateParams = stateParamsMock;
//                      // this is to bypass teh check for $window.localStorage.assessment.
//                      scope.checkForAssessment = function () { return false; };
//                      createController = function () {
//                          return $controller('AlgorithmsController', {
//                              $scope: scope,
//                              AssessmentInstanceBuilder: AssessmentInstanceBuilderMock,
//                              RecommendationEngine: RecommendationEngineMock,
//                              Constants: ConstantsMock,
//                              $stateParams: stateParamsMock
//                          });
//                      };
//                  });
//              });
//
//              describe("Single-task load the selections", function () {
//                  it("for a single-task", function () {
//                      stateParamsMock = {
//                          algorithms: [],
//                          section: "single-task",
//                          nowDoAssessment: 'yes'
//                      };
//                      var controller = createController();
//
//                      expect(scope.singleMultiChoice).toEqual('radio');
//                  });
//                  it("and loads the all the questions ", function () {
//                      stateParamsMock = {
//                          algorithms: [],
//                          section: "single-task",
//                          nowDoAssessment: 'yes'
//                      };
//                      var controller = createController();
//
//                      expect(scope.chosenAlgorithms).toEqual(ConstantsMock.questions[0]);
//                      expect(scope.algorithmList).toEqual(ConstantsMock.algorithms);
//                  });
//              });
//              describe("Multi-task load the selections", function () {
//                  it("for a multi-task", function () {
//                      stateParamsMock = {
//                          algorithms: [],
//                          section: "multi-tasks",
//                          nowDoAssessment: 'no'
//                      };
//                      var controller = createController();
//
//                      expect(scope.singleMultiChoice).toEqual('checkbox');
//                  });
//              });
//              describe("Saves the selected Algorithms", function () {
//                  it('save for a single-task', inject(function ($state) {
//                      stateParamsMock = {
//                          algorithms: [angular.fromJson(ConstantsMock.algorithms)],
//                          section: "single-task",
//                          nowDoAssessment: 'yes'
//                      };
//                      var controller = createController();
//
//                      scope.next();
//                      expect($state.go).toHaveBeenCalledWith('^.assessment', {
//                          section: stateParamsMock.section,
//                          algorithms: stateParamsMock.algorithms,
//                          nowDoAssessment: 'yes'
//                      });
//                  }));
//                  it('save for a multi-task', inject(function ($state) {
//                      stateParamsMock = {
//                          algorithms: [angular.fromJson(ConstantsMock.algorithms)],
//                          section: "multi-tasks",
//                          nowDoAssessment: 'no'
//                      };
//                      var controller = createController();
//
//                      scope.next();
//                      expect($state.go).toHaveBeenCalledWith('^.recommendations', {
//                          section: stateParamsMock.section,
//                          algorithms: stateParamsMock.algorithms,
//                          nowDoAssessment: 'no'
//                      });
//                  }));
//                  it('save for a missing state', inject(function ($state) {
//                      stateParamsMock = {
//                          section: stateParamsMock.section,
//                          algorithms: [angular.fromJson(ConstantsMock.algorithms)],
//                          nowDoAssessment: 'no'
//                      };
//                      var controller = createController();
//
//                      scope.next();
//                      expect($state.go).toHaveBeenCalledWith('^.recommendations', {
//                          section: stateParamsMock.section,
//                          algorithms: stateParamsMock.algorithms,
//                          nowDoAssessment: 'no'
//                      });
//                  }));
//              });
//              describe("Misc. Functions tested here", function () {
//                  it("opens the flowchart in a new window", function () {
//                      stateParamsMock = {
//                          algorithms: [angular.fromJson(ConstantsMock.algorithms)],
//                          section: "multi-tasks",
//                          nowDoAssessment: 'no'
//                      };
//                      var controller = createController();
//
//                      scope.viewFlowChart(ConstantsMock.algorithms[0].flowChart);
//                      expect(windowMock.open).toHaveBeenCalledWith(ConstantsMock.algorithms[0].flowChart, '_blank');
//                      scope.viewFlowChart();
//                      expect(windowMock.open).toHaveBeenCalledWith(undefined, '_blank');
//                  });
//              });
//          });
//      });
