/*jslint node: true */
/*global define, describe, beforeEach, inject, it, expect */

define(['HomeController'], function () {
    'use strict';

    describe("The HomeController controller", function () {
        var controller,
            scope,
            focusServiceMock,
            pageServiceMock;

        beforeEach(function () {
            module('angularTemplateApp');

            focusServiceMock = jasmine.createSpyObj('focusService', ['focusMain']);
            pageServiceMock = jasmine.createSpyObj('pageService', ['redirectToLaunchpad']);

            module(function ($provide) {
                $provide.value('focusService', focusServiceMock);
                $provide.value('pageService', pageServiceMock);
            });

            inject(function ($controller, $rootScope) {
                scope = $rootScope.$new();

                controller = $controller('HomeController', {
                    $scope: scope
                });
            });
        });

        it("should load", function () {
            expect(focusServiceMock.focusMain).toHaveBeenCalled();
        });
    });
});