/*jslint node: true, unparam: true */
/*global constant: true */

define([
    'angular',
    'app',

    'text!modules/sast/core/constants/algorithm-1/algorithm_1_notes.html',
    'text!modules/sast/core/constants/algorithm-1/algorithm_1_recommendation_1.html',
    'text!modules/sast/core/constants/algorithm-1/algorithm_1_recommendation_2.html',
    'text!modules/sast/core/constants/algorithm-1/algorithm_1_recommendation_3.html',
    'text!modules/sast/core/constants/algorithm-1/algorithm_1_recommendation_4.html',
    'text!modules/sast/core/constants/algorithm-1/algorithm_1_recommendation_5.html',

    'text!modules/sast/core/constants/algorithm-2/algorithm_2_notes.html',
    'text!modules/sast/core/constants/algorithm-2/algorithm_2_recommendation_1.html',
    'text!modules/sast/core/constants/algorithm-2/algorithm_2_recommendation_2.html',
    'text!modules/sast/core/constants/algorithm-2/algorithm_2_recommendation_3.html',
    'text!modules/sast/core/constants/algorithm-2/algorithm_2_recommendation_4.html',
    'text!modules/sast/core/constants/algorithm-2/algorithm_2_recommendation_5.html',
    'text!modules/sast/core/constants/algorithm-2/algorithm_2_recommendation_6.html',

    'text!modules/sast/core/constants/algorithm-3/algorithm_3_notes.html',
    'text!modules/sast/core/constants/algorithm-3/algorithm_3_recommendation_1.html',
    'text!modules/sast/core/constants/algorithm-3/algorithm_3_recommendation_2.html',
    'text!modules/sast/core/constants/algorithm-3/algorithm_3_recommendation_3.html',
    'text!modules/sast/core/constants/algorithm-3/algorithm_3_recommendation_4.html',
    'text!modules/sast/core/constants/algorithm-3/algorithm_3_recommendation_5.html',

    'text!modules/sast/core/constants/algorithm-4/algorithm_4_notes.html',
    'text!modules/sast/core/constants/algorithm-4/algorithm_4_recommendation_1.html',
    'text!modules/sast/core/constants/algorithm-4/algorithm_4_recommendation_2.html',
    'text!modules/sast/core/constants/algorithm-4/algorithm_4_recommendation_3.html',
    'text!modules/sast/core/constants/algorithm-4/algorithm_4_recommendation_4.html',
    'text!modules/sast/core/constants/algorithm-4/algorithm_4_recommendation_5.html',

    'text!modules/sast/core/constants/algorithm-5/algorithm_5_notes.html',
    'text!modules/sast/core/constants/algorithm-5/algorithm_5_recommendation_1.html',
    'text!modules/sast/core/constants/algorithm-5/algorithm_5_recommendation_2.html',
    'text!modules/sast/core/constants/algorithm-5/algorithm_5_recommendation_3.html',
    'text!modules/sast/core/constants/algorithm-5/algorithm_5_recommendation_4.html',
    'text!modules/sast/core/constants/algorithm-5/algorithm_5_recommendation_5.html',

    'text!modules/sast/core/constants/algorithm-6/algorithm_6_notes.html',
    'text!modules/sast/core/constants/algorithm-6/algorithm_6_recommendation_1.html',
    'text!modules/sast/core/constants/algorithm-6/algorithm_6_recommendation_2.html',
    'text!modules/sast/core/constants/algorithm-6/algorithm_6_recommendation_3.html',
    'text!modules/sast/core/constants/algorithm-6/algorithm_6_recommendation_4.html',
    'text!modules/sast/core/constants/algorithm-6/algorithm_6_recommendation_5.html'
], function (angular,
             app,
             incomingAlgorithm_1_notes_1,
             incomingAlgorithm_1_recommendation_1,
             incomingAlgorithm_1_recommendation_2,
             incomingAlgorithm_1_recommendation_3,
             incomingAlgorithm_1_recommendation_4,
             incomingAlgorithm_1_recommendation_5,

             incomingAlgorithm_2_notes_1,
             incomingAlgorithm_2_recommendation_1,
             incomingAlgorithm_2_recommendation_2,
             incomingAlgorithm_2_recommendation_3,
             incomingAlgorithm_2_recommendation_4,
             incomingAlgorithm_2_recommendation_5,
             incomingAlgorithm_2_recommendation_6,

             incomingAlgorithm_3_notes_1,
             incomingAlgorithm_3_recommendation_1,
             incomingAlgorithm_3_recommendation_2,
             incomingAlgorithm_3_recommendation_3,
             incomingAlgorithm_3_recommendation_4,
             incomingAlgorithm_3_recommendation_5,

             incomingAlgorithm_4_notes_1,
             incomingAlgorithm_4_recommendation_1,
             incomingAlgorithm_4_recommendation_2,
             incomingAlgorithm_4_recommendation_3,
             incomingAlgorithm_4_recommendation_4,
             incomingAlgorithm_4_recommendation_5,

             incomingAlgorithm_5_notes_1,
             incomingAlgorithm_5_recommendation_1,
             incomingAlgorithm_5_recommendation_2,
             incomingAlgorithm_5_recommendation_3,
             incomingAlgorithm_5_recommendation_4,
             incomingAlgorithm_5_recommendation_5,

             incomingAlgorithm_6_notes_1,
             incomingAlgorithm_6_recommendation_1,
             incomingAlgorithm_6_recommendation_2,
             incomingAlgorithm_6_recommendation_3,
             incomingAlgorithm_6_recommendation_4,
             incomingAlgorithm_6_recommendation_5) {
    'use strict';

    var algorithm_1_notes               = incomingAlgorithm_1_notes_1.toString(),
        algorithm_1_recommendation_1    = incomingAlgorithm_1_recommendation_1.toString(),
        algorithm_1_recommendation_2    = incomingAlgorithm_1_recommendation_2.toString(),
        algorithm_1_recommendation_3    = incomingAlgorithm_1_recommendation_3.toString(),
        algorithm_1_recommendation_4    = incomingAlgorithm_1_recommendation_4.toString(),
        algorithm_1_recommendation_5    = incomingAlgorithm_1_recommendation_5.toString(),

        algorithm_2_notes               = incomingAlgorithm_2_notes_1.toString(),
        algorithm_2_recommendation_1    = incomingAlgorithm_2_recommendation_1.toString(),
        algorithm_2_recommendation_2    = incomingAlgorithm_2_recommendation_2.toString(),
        algorithm_2_recommendation_3    = incomingAlgorithm_2_recommendation_3.toString(),
        algorithm_2_recommendation_4    = incomingAlgorithm_2_recommendation_4.toString(),
        algorithm_2_recommendation_5    = incomingAlgorithm_2_recommendation_5.toString(),
        algorithm_2_recommendation_6    = incomingAlgorithm_2_recommendation_6.toString(),

        algorithm_3_notes               = incomingAlgorithm_3_notes_1.toString(),
        algorithm_3_recommendation_1    = incomingAlgorithm_3_recommendation_1.toString(),
        algorithm_3_recommendation_2    = incomingAlgorithm_3_recommendation_2.toString(),
        algorithm_3_recommendation_3    = incomingAlgorithm_3_recommendation_3.toString(),
        algorithm_3_recommendation_4    = incomingAlgorithm_3_recommendation_4.toString(),
        algorithm_3_recommendation_5    = incomingAlgorithm_3_recommendation_5.toString(),

        algorithm_4_notes               = incomingAlgorithm_4_notes_1.toString(),
        algorithm_4_recommendation_1    = incomingAlgorithm_4_recommendation_1.toString(),
        algorithm_4_recommendation_2    = incomingAlgorithm_4_recommendation_2.toString(),
        algorithm_4_recommendation_3    = incomingAlgorithm_4_recommendation_3.toString(),
        algorithm_4_recommendation_4    = incomingAlgorithm_4_recommendation_4.toString(),
        algorithm_4_recommendation_5    = incomingAlgorithm_4_recommendation_5.toString(),

        algorithm_5_notes               = incomingAlgorithm_5_notes_1.toString(),
        algorithm_5_recommendation_1    = incomingAlgorithm_5_recommendation_1.toString(),
        algorithm_5_recommendation_2    = incomingAlgorithm_5_recommendation_2.toString(),
        algorithm_5_recommendation_3    = incomingAlgorithm_5_recommendation_3.toString(),
        algorithm_5_recommendation_4    = incomingAlgorithm_5_recommendation_4.toString(),
        algorithm_5_recommendation_5    = incomingAlgorithm_5_recommendation_5.toString(),

        algorithm_6_notes               = incomingAlgorithm_6_notes_1.toString(),
        algorithm_6_recommendation_1    = incomingAlgorithm_6_recommendation_1.toString(),
        algorithm_6_recommendation_2    = incomingAlgorithm_6_recommendation_2.toString(),
        algorithm_6_recommendation_3    = incomingAlgorithm_6_recommendation_3.toString(),
        algorithm_6_recommendation_4    = incomingAlgorithm_6_recommendation_4.toString(),
        algorithm_6_recommendation_5    = incomingAlgorithm_6_recommendation_5.toString();

    app.constant('SASTConstants',
        {
            algorithms: [
                {
                    id: 1,
                    flowChart: '_assets/images/algorithms/algorithm-1-quiz.jpg',
                    name: 'Transfer: Bed to Chair, Chair to Toilet, Chair to Chair, Car to Chair', // really set in ui-router, this for tracking only
                    //  ----------------------
                    //  Score   Recommendation
                    //  0       1
                    //  1       2
                    //  2       3
                    //  3       4
                    //  4       5
                    //  ----------------------
                    notes: algorithm_1_notes,
                    solutions: [
                        {
                            recommendation: algorithm_1_recommendation_1
                        }, {
                            recommendation: algorithm_1_recommendation_2
                        }, {
                            recommendation: algorithm_1_recommendation_3
                        }, {
                            recommendation: algorithm_1_recommendation_4
                        }, {
                            recommendation: algorithm_1_recommendation_5
                        }, {
                            recommendation: algorithm_1_recommendation_5
                        }
                    ]
                }, {
                    id: 2,
                    flowChart: '_assets/images/algorithms/algorithm-2-quiz.jpg',
                    name: 'Lateral Transfer to & From: Bed to Stretcher/Trolley', // really set in ui-router, this for tracking only
                    //  ----------------------
                    //  Score   Recommendation
                    //  0       1
                    //  1       2
                    //  2       3
                    //  3       4
                    //  4       5
                    //  4-4C    7
                    //  ----------------------
                    notes: algorithm_2_notes,
                    solutions: [
                        {
                            recommendation: algorithm_2_recommendation_1
                        }, {
                            recommendation: algorithm_2_recommendation_2
                        }, {
                            recommendation: algorithm_2_recommendation_3
                        }, {
                            recommendation: algorithm_2_recommendation_4
                        }, {
                            recommendation: algorithm_2_recommendation_5
                        }, {
                            recommendation: algorithm_2_recommendation_6
                        }
                    ]
                }, {
                    id: 3,
                    flowChart: '_assets/images/algorithms/algorithm-3-quiz.jpg',
                    name: 'Transfer To & From: Chair to Stretcher or Chair to Exam Table', // really set in ui-router, this for tracking only
                    //  ----------------------
                    //  Score   Recommendation
                    //  0       1
                    //  1       2
                    //  2       3
                    //  3       4
                    //  4       5
                    //  ----------------------
                    notes: algorithm_3_notes,
                    solutions: [
                        {
                            recommendation: algorithm_3_recommendation_1
                        }, {
                            recommendation: algorithm_3_recommendation_2
                        }, {
                            recommendation: algorithm_3_recommendation_3
                        }, {
                            recommendation: algorithm_3_recommendation_4
                        }, {
                            recommendation: algorithm_3_recommendation_5
                        }
                    ]
                }, {
                    id: 4,
                    flowChart: '_assets/images/algorithms/algorithm-4-quiz.jpg',
                    name: 'Reposition up in Bed: Side to Side, Up in Bed', // really set in ui-router, this for tracking only
                    //  ----------------------
                    //  Score   Recommendation
                    //  0       1
                    //  1       2
                    //  2       3
                    //  3       4
                    //  4       5
                    //  ----------------------
                    notes: algorithm_4_notes,
                    solutions: [
                        {
                            recommendation: algorithm_4_recommendation_1
                        }, {
                            recommendation: algorithm_4_recommendation_2
                        }, {
                            recommendation: algorithm_4_recommendation_3
                        }, {
                            recommendation: algorithm_4_recommendation_4
                        }, {
                            recommendation: algorithm_4_recommendation_5
                        }
                    ]
                }, {
                    id: 5,
                    flowChart: '_assets/images/algorithms/algorithm-5-quiz.jpg',
                    name: 'Reposition in Chair: Wheelchair & Dependency Chair', // really set in ui-router, this for tracking only
                    //  ----------------------
                    //  Score   Recommendation
                    //  0       1
                    //  1       2
                    //  2       3
                    //  3       4
                    //  4       5
                    //  ----------------------
                    notes: algorithm_5_notes,
                    solutions: [
                        {
                            recommendation: algorithm_5_recommendation_1
                        }, {
                            recommendation: algorithm_5_recommendation_2
                        }, {
                            recommendation: algorithm_5_recommendation_3
                        }, {
                            recommendation: algorithm_5_recommendation_4
                        }, {
                            recommendation: algorithm_5_recommendation_5
                        }
                    ]
                }, {
                    id: 6,
                    flowChart: '_assets/images/algorithms/algorithm-6-quiz.jpg',
                    name: 'Transfer a Patient up from floor', // really set in ui-router, this for tracking only
                    //  ----------------------
                    //  Score   Recommendation
                    //  0       1
                    //  1       2
                    //  2       3
                    //  3       4
                    //  4       5
                    //  ----------------------
                    notes: algorithm_6_notes,
                    solutions: [
                        {
                            recommendation: algorithm_6_recommendation_1
                        }, {
                            recommendation: algorithm_6_recommendation_2
                        }, {
                            recommendation: algorithm_6_recommendation_3
                        }, {
                            recommendation: algorithm_6_recommendation_4
                        }, {
                            recommendation: algorithm_6_recommendation_5
                        }
                    ]
                }
            ],
            questions: [
                {
                    "id": 1,
                    "question": "Patient’s Level of Assistance:",
                    "options": [
                        "No Help Needed – The patient is independent, standby for safety only, needs no staff assist ",
                        "The patient needs minimal to moderate help, light touch, verbal cues – Staff is required to lift <35 #",
                        "Dependent—Patient requires staff to lift > 35# or the patient has unpredictable strength/high risk for fall during the reposition. In this case assistive devices need to be used for safe moves."
                    ],
                    "score": [0, 1, 2]
                }, {
                    "id": 2,
                    "question": "Lower extremity ability to bear weight",
                    "options": [
                        "Bilateral Weight Bearing",
                        "Bilateral but the legs are weak",
                        "Unilateral weight bearing",
                        "None (Inconsistent = none)"
                    ],
                    "score": [0, 1, 1, 2]
                }, {
                    "id": 3,
                    "question": "Upper Extremity Strength and Hand grasp",
                    "options": [
                        "Bilateral strength and hand grasp present",
                        "Bilateral but the arms are weak",
                        "Unilateral Upper extremity Strength/grasp",
                        "No upper body strength/ability to grasp"
                    ],
                    "score": [0, 1, 1, 2]
                }, {
                    "id": 4,
                    "question": "Does the patient understand direction, cooperate, and follow simple commands?",
                    "options": [
                        "Yes",
                        "No (Highly Unpredictable, behavior varies. Obtain new score prior to every move)",
                        "Combative during hands on care/transfers"
                    ],
                    "score": [0, 2, 3]
                }, {
                    "id": 5,
                    "question": "Height and Weight Score",
                    "options": [
                        "Over 200 pounds or 6 feet tall and currently has mobility issues –(If the patient has a BMI over 50 or weighs over 300 pounds consider using the Comprehensive Patient Assessment & Algorithms)"
                    ],
                    "score": [0, 1]
                }, {
                    "id": 6,
                    "question": "Check with front line staff - Does the patient have medical or mental conditions that may be likely to affect transfer/repositioning techniques such as medical instability, fractures, recent major surgery, chest pain, pressure ulcers, high risk for falls, or extremely dizzy. ",
                    "options": [
                        "If there are no additional factors that complicate patient transfer",
                        "Add 1 If additional factors that make the movement/transfer more difficult per primary nurse"
                    ],
                    "score": [0, 1]
                }
            ]
        }
    );
});