/*jslint node: true */
/*global define */

define(['angular', 'app'], function (angular, app) {
    "use strict";
    app.service('SASTAssessmentService', function ($window, SASTConstants, $log, $state, $stateParams) {
        // Service is used to track the Questions.
        // Functions
        //      - returnSpecificAlgorithmQuestions
        //      - save
        //      - delete
        // Flow:

        $log.info('SASTAssessmentService start');
        //  $log.info($state);
        //  $log.info($stateParams);

        // -------------------------------------------------------------------------------------------------------------
        // -    Init Section, setting default values.
        // -------------------------------------------------------------------------------------------------------------
        var Assessment = function () {
            this.assessment = angular.fromJson($window.localStorage.sastAssessment) || angular.copy(SASTConstants.questions);
        };

        Assessment.prototype.returnQuestions = function () {
            return angular.fromJson($window.localStorage.sastAssessment) || angular.copy(SASTConstants.questions);
        };

        Assessment.prototype.save = function (assessment) {
            $window.localStorage.sastAssessment = angular.toJson(assessment);
        };

        Assessment.prototype.delete = function () {
            $log.info('AssessmentService.delete');
            delete $window.localStorage.sastAssessment;
            this.assessment = angular.copy(SASTConstants.questions);
        };

        return Assessment;
    });
});


