/*jslint node: true, unparam: true */
/*global define, describe, beforeEach, inject, it, expect */

define([
    'SASTAssessmentService',
    'SASTConstants'
], function (SASTAssessmentService, SASTConstants) {
    'use strict';

    describe("The Assessment Service", function () {
        var AssessmentService,
            Constants,
            mockAssessment;

        // -------------------------------------------------------------------------------------------------------------
        // -   Variables
        // -------------------------------------------------------------------------------------------------------------
        mockAssessment = [
            {
                "id": 1,
                "question": "Patient’s Level of Assistance:",
                "options": [
                    "No Help Needed – The patient is independent, standby for safety only, needs no staff assist ",
                    "The patient needs minimal to moderate help, light touch, verbal cues – Staff is required to lift <35 #",
                    "Dependent—Patient requires staff to lift > 35# or the patient has unpredictable strength/high risk for fall during the reposition. In this case assistive devices need to be used for safe moves."
                ],
                "score": [0, 1, 2]
            }, {
                "id": 2,
                "question": "Lower extremity ability to bear weight",
                "options": [
                    "Bilateral Weight Bearing",
                    "Bilateral but the legs are weak",
                    "Unilateral weight bearing",
                    "None (Inconsistent = none)"
                ],
                "score": [0, 1, 1, 2]
            }, {
                "id": 3,
                "question": "Upper Extremity Strength and Hand grasp",
                "options": [
                    "Bilateral strength and hand grasp present",
                    "Bilateral but the arms are weak",
                    "Unilateral Upper extremity Strength/grasp",
                    "No upper body strength/ability to grasp"
                ],
                "score": [0, 1, 1, 2]
            }, {
                "id": 4,
                "question": "Does the patient understand direction, cooperate, and follow simple commands?",
                "options": [
                    "Yes",
                    "No (Highly Unpredictable, behavior varies. Obtain new score prior to every move)",
                    "Combative during hands on care/transfers"
                ],
                "score": [0, 2, 3]
            }, {
                "id": 5,
                "question": "Height and Weight Score",
                "options": [
                    "under 200 pounds",
                    "over 200 pounds or 6 feet tall and currently has mobility issues (If the patient has a BMI over 50 or weighs over 300 pounds consider using the  Comprehensive Patient ….)"
                ],
                "score": [0, 1]
            }, {
                "id": 6,
                "question": "Check with front line staff - Does the patient have medical or mental conditions that may be likely to affect transfer/repositioning techniques such as medical instability, fractures, recent major surgery, chest pain, pressure ulcers, high risk for falls, or extremely dizzy. ",
                "options": [
                    "If there are no additional factors that complicate patient transfer",
                    "Add 1 If additional factors that make the movement/transfer more difficult per primary nurse"
                ],
                "score": [0, 1]
            }
        ];

        // -------------------------------------------------------------------------------------------------------------
        // -   Building out Controller and Inserting $provide and spy's
        // -------------------------------------------------------------------------------------------------------------
        beforeEach(function () {
            module('angularTemplateApp');

            inject(function (_SASTAssessmentService_, _SASTConstants_) {
                AssessmentService = _SASTAssessmentService_;
                Constants = _SASTConstants_;
            });
        });

        describe("should load", function () {
            it("by passing", function () {
                var service = new AssessmentService();
                expect(service.returnQuestions).toBeDefined();
                expect(service.save).toBeDefined();
                expect(service.delete).toBeDefined();
            });
        });
    });
});