/*jslint node: true, unparam: true */
/*global define, describe, beforeEach, inject, it, expect */

define([
    'SASTConstants',
    'SASTAssessmentController',
    'SASTAssessmentService'
], function (SASTConstants,
             SASTAssessmentController,
             SASTAssessmentService) {
    'use strict';

    describe("The SASTRecommendationsController controller", function () {
        var controller,
            createController,
            scope,
            stateParams,
            stateParamsMock;

        // -------------------------------------------------------------------------------------------------------------
        // -   Variables
        // -------------------------------------------------------------------------------------------------------------
        stateParamsMock = {
            section: "algorithm-01",
            sectionIndex: 1,
            sectionName: "Transfer: Bed to Chair, Chair to Toilet, Chair to Chair, Car to Chair",
            score: 0
        };


        // -------------------------------------------------------------------------------------------------------------
        // -   Building out Controller and Inserting $provide and spy's
        // -------------------------------------------------------------------------------------------------------------
        beforeEach(function () {
            module('angularTemplateApp');

            inject(function ($controller, $rootScope, _SASTConstants_, _SASTAssessmentService_) {
                scope = $rootScope.$new();
                stateParams = stateParamsMock;
                SASTConstants = _SASTConstants_;
                SASTAssessmentService = _SASTAssessmentService_;
                scope.score = 4;

                createController = function () {
                    return $controller('SASTAssessmentController', {
                        $scope: scope,
                        SASTAssessmentService: _SASTAssessmentService_,
                        SASTConstants: SASTConstants,
                        $stateParams: stateParamsMock
                    });
                };
                // this way if I need to re-instantiate the controller within and 'it' I could by calling this line.
                controller = createController();
            });
        });

        describe("should load", function () {
            it("the controller", function () {
                controller = createController();
                expect(scope.next).toBeDefined();
                expect(scope.questions).toEqual(SASTConstants.questions);
            });
        });
    });
});
