/*jslint node: true, unparam: true */
/*global define, controller */

define(['angular', 'app'], function (angular, app) {
    'use strict';
    app.controller('SASTRecommendationsController', function ($scope, $rootScope, $state, $stateParams, $log, SASTAssessmentService, SASTConstants, SASTRecommendationEngine) {
        // Controller is used to show all or a subset of the Questions.
        // Functions:
        //      -
        // Flow:
        //      -

        $log.info('SASTRecommendationsController:');
        // ---------------------------------------------------------------------------------------------------------
        // -    Init Section, setting default values.
        // ---------------------------------------------------------------------------------------------------------
        var service = new SASTAssessmentService(),
            questions = service.returnQuestions(),
            realScore,
            realIndex;

        $scope.score = SASTRecommendationEngine.score(questions);
        // force an update to the top level score.
        $rootScope.$emit('UpdateScore', $scope.score);

        // we subtract one because we're accessing an index of an array.
        // not for realScore; because we can have a score of 0, up to 4.  That matches our indexes.
        realScore = $scope.score;
        realIndex = $stateParams.sectionIndex - 1;
        // the Algorithm so we can show title, etc.
        // The solution is the recommendation only. (only dynamic part)
        // Notes is actually in the algorithm section.
        $scope.algorithm = SASTConstants.algorithms[realIndex];
        $scope.solution = SASTConstants.algorithms[realIndex].solutions[realScore];
    });
});