define(['angular', 'app', 'global'], function (angular, app) {
	'use strict';

	app.controller('AboutController', function ($scope, $modalInstance, $timeout, pageService, focusService) {

		$scope.acknowledgements = {
			groups: [
						{
							id: 1,
							title: 'Acknowledgements',
							template: 'src/ui-components/modals/about/partials/acknowledgements_partial.html',
							open: false
						}
					]
		};

		$scope.$watch(function () {
			return $('div.modal-header h3').is(":visible");
		}, function (isVisible, wasVisible) {
			if (isVisible && !wasVisible) {
				focusService.focusElement($('div.modal-header h3'));
			}
		});
		$scope.version = pageService.getVersionNumber();

		$scope.ok = function () {
			$modalInstance.close();
		};

		$scope.showEula = function () {
			window.open("src/ui-components/modals/about/eula.html", "_blank", "location=no,scrollbars=1,resizable=1");
		};

	});
});