define(['angular', 'app', 'global'], function (angular, app) {
    'use strict';

    app.controller('ClearController', function ($scope, $state, $modalInstance, $timeout, pageService, focusService, snapRemote, AssessmentService, SASTAssessmentService, RecommendationEngine) {

        // Focuses on Modal
        $scope.$watch(function () {
            return $('div.modal-header h3').is(":visible");
        }, function (isVisible, wasVisible) {
            if (isVisible && !wasVisible) {
                // timeout to digest and focus the header.
                $timeout(function () {
                    focusService.focusElement(angular.element('div.modal-header h3'), true);
                }, 50);
                // This will close the sidebar; but AFTER focus is made to modal
                // otherwise it's a race the focusService loses each time.
                snapRemote.close();
                $rootScope.$digest();
            }
        });

        // Called via main left nav on bottom.
        // Will clear out all the stored localStorage for the various algorithms.
        // Rather than duplicate code; we call the services directly here.
        $scope.clearAllData = function () {

            var sastService = new SASTAssessmentService(),
                cpaaService = new AssessmentService();

            sastService.delete();
            cpaaService.delete();
            RecommendationEngine.clearChosenAlgorithms();
            RecommendationEngine.clearSelectedAlgorithms();

            $modalInstance.close();

            // Now that we've deleted all the assessment stuff; take them home.
            $state.go('main.home');
        };
        $scope.cancel = function () {
            $modalInstance.close();
        };

    });
});