// Karma configuration
// http://karma-runner.github.io/0.10/config/configuration-file.html

module.exports = function (config) {
    config.set({
        // base path, that will be used to resolve files and exclude
        basePath: '',

        // testing framework to use (jasmine/mocha/qunit/...)
        frameworks: ['jasmine', "requirejs"],

        plugins: [
            'karma-requirejs',
            'karma-phantomjs-launcher',
            'karma-jasmine',
            'karma-junit-reporter',
            'karma-threshold-reporter',
            'karma-ng-html2js-preprocessor',
            'karma-spec-reporter',
            'karma-coverage'
        ],

        // list of files / patterns to load in the browser
        files: [
            //  {pattern: 'app/libs/angular-mocks/js/angular-mocks.js', included: false},
            //  {pattern: 'app/libs/angular-sanitize/js/angular-sanitize.js', included: false},
            //  {pattern: 'app/libs/angular-ui-router/js/angular-ui-router.js', included: false},
            //  {pattern: 'app/libs/angular-busy/js/angular-busy.js', included: false},
            {pattern: 'app/**/*.js', included: false},
            {pattern: 'app/**/**/*.js', included: false},
            {pattern: 'app/**/*.json', included: false},
            {pattern: 'app/src/modules/**/core/constants/*.*', included: false},
            {pattern: 'app/src/modules/**/core/constants/**/*.*', included: false},
            {pattern: 'test/spec/*.js', included: false},
            {pattern: 'app/src/ui-components/**/*.html', included: false},
            'test/config.js'
        ],

        // list of files / patterns to exclude
        // was 'app/scripts/config.js'
        // should be src??
        exclude: [
            'app/scripts/config.js'
        ],

        // web server port
        port: 8888,

        colors: true,

        // level of logging
        // possible values: LOG_DISABLE || LOG_ERROR || LOG_WARN || LOG_INFO || LOG_DEBUG
        logLevel: config.LOG_WARN,

        // enable / disable watching file and executing tests whenever any file changes
        autoWatch: false,

        includeBaseline: true,

        // Start these browsers, currently available:
        // - Chrome
        // - ChromeCanary
        // - Firefox
        // - Opera
        // - Safari (only Mac)
        // - PhantomJS
        // - IE (only Windows)
        browsers: ['PhantomJS'],

        // Continuous Integration mode
        // if true, it capture browsers, run tests and exit
        singleRun: false,

        // COverage fails, so disabling now.
        reporters: ['progress', 'junit', 'threshold', 'spec'],

        preprocessors: {
            'app/src/modules/**/!(*_spec).js': ['coverage'],
            //  'app/src/modules/!templates.js': ['coverage'],
            'app/src/ui-components/**/*.html': ['ng-html2js']
        },

        thresholdReporter: {
            statements: 90,
            branches: 60,
            functions: 85,
            lines: 90
        },

        coverageReporter: {
            reporters: [
                {
                    type : 'html',
                    dir : 'coverage/'
                }, {
                    type: 'lcov',
                    dir: 'coverage/'
                }, {
                    type: 'cobertura'
                }]
        },
        // the default configuration. Generates the junit test report.
        junitReporter: {
            outputFile: 'coverage/junit-test-results.xml',
            suite: ''
        }
    });
};
