var tests = [];
for (var file in window.__karma__.files) {
	if (window.__karma__.files.hasOwnProperty(file)) {
		// Removed "Spec" naming from files
		if (/_spec\.js$/.test(file)) {
			tests.push(file);
		}
	}
}

requirejs.config({
	// Karma serves files from '/base'
	baseUrl: '/base/app/src',

	paths: {
		angularMocks					: '../libs/angular-mocks/js/angular-mocks',

		/*                  Libraries                    */
		'angular'						: '../libs/angular/js/angular',
		'angularSanitize'				: '../libs/angular-sanitize/js/angular-sanitize',
		'angularTouch'					: '../libs/angular-touch/js/angular-touch',
		'angularAnimate'				: '../libs/angular-animate/js/angular-animate',
		'jQuery'						: '../libs/jquery/js/jquery',
		'text'							: '../libs/requirejs-text/text',
		'angularUiUtils'				: '../libs/angular-ui-utils/js/ui-utils',
		'angularUiRouter'				: '../libs/angular-ui-router/js/angular-ui-router',
		'angularUiBootstrap'			: '../libs/angular-bootstrap/js/ui-bootstrap-tpls',
		'angularBusy'					: '../libs/angular-busy/js/angular-busy',
		'snap'							: '../libs/snap/js/snap',
		'angularSnap'					: '../libs/angular-snap/js/angular-snap',
		'highstocks'					: '../libs/highstock/js/highstock.src',
		'highcharts-ng'					: '../libs/highcharts-ng/js/highcharts-ng',
		'clampjs'						: '../libs/Clamp.js/clamp',
		'moment'						: '../libs/moment/js/moment',
		'Modernizr'						: '../libs/modernizr/modernizr.custom',


		/*                  Decorations                    */
		'uiCollapseDirective'			: 'decorations/ui-collapse_decorator',
        'ngClickDirective'			    : 'decorations/ng-click_decorator',
        'uiMaskDirective'			    : 'decorations/ui-mask_decorator',

		/*                  Application                    */
		'appConfig'						: 'app-config',
		'app'							: '../../test/spec/appMock',
		'router'						: 'router',
		//templates is generated by grunt ngtemplate task
		'templates'						: 'templates',
		'ResponsiveDirective'			: 'ui-components/responsive/responsive_directive',


		/*                  Container                    */
		'MainController'				: 'container/main/main_controller',
		'SplashController'				: 'container/splash/splash_controller',

		'HeaderController'				: 'container/components/header/header_controller',
		'FooterController'				: 'container/components/footer/footer_controller',
		'TwoPanelController'			: 'container/components/content/two-column_controller',
		'List'							: 'container/components/content/list/list_directive',
		'Menu'							: 'container/components/menu/menu_directive',
		'SecondaryNavigationController' : 'container/components/content/secondary-navigation/secondary-navigation_controller',


		/*                  Modules                    */
        'HomeController'				: 'modules/home/pages/home_controller',
        'CPAAPrimaryWrapperController'	: 'modules/cpaa/components/primary-wrapper/cpaa-primary-wrapper_controller',
        'AssessmentController'	        : 'modules/cpaa/pages/assessment/assessment_controller',
        'AlgorithmsController'	        : 'modules/cpaa/pages/algorithms/algorithms_controller',
        'RecommendationsController'	    : 'modules/cpaa/pages/recommendations/recommendations_controller',
        'RecommendationEngine'	        : 'modules/cpaa/core/recommendation-engine',
        'AssessmentService'	            : 'modules/cpaa/core/assessment_service',
        'AssessmentInstanceBuilder'	    : 'modules/cpaa/core/assessment-instance-builder',
        'Constants'	                    : 'modules/cpaa/core/constants',

        'SASTModule'					: 'modules/sast/sast_module',
        'SASTConstants'					: 'modules/sast/core/constants',
        'SASTAssessmentService'         : 'modules/sast/core/sast_assessment_service',
        'SASTRecommendationEngine'      : 'modules/sast/core/sast_recommendation_engine',
        'SASTController'				: 'modules/sast/pages/sast/sast_controller',
        'SASTPrimaryWrapperController'  : 'modules/sast/components/primary-wrapper/sast_primary_wrapper_controller',
        'SASTAssessmentController'      : 'modules/sast/pages/assessment/sast_assessment_controller',
        'SASTRecommendationsController' : 'modules/sast/pages/recommendations/sast_recommendations_controller',

		/*                  Core Components                    */
		'httpMock'						: 'core/services/http-mock_service',

		'httpInterceptor'				: 'core/connection/httpInterceptor',
		'connection_error_service'		: 'core/connection/connection_error_service',
		'connection_timeout_service'	: 'core/connection/connection_timeout_service',
		'delayManager'					: 'core/connection/delay_factory',

		'EulaController'				: 'core/eula/eula_controller',
		'eula_service'					: 'core/eula/eula_service',

		'localResourceDirectoryService'	: 'core/resources/local-resource-directory_service',
		'mhpuser_service'				: 'core/resources/mhpuser_service',
		'patient'						: 'core/resources/patient_service',
		'resourcedirectory_service'		: 'core/resources/resourcedirectory_service',
		'NotificationsService'			: 'core/resources/notifications_service',

		'AbstractCRUDService'           : 'core/services/abstract-crud_service',
		'CollectionCRUDService'		    : 'core/services/collection-crud_service',
		'BaseCRUDService'               : 'core/services/base-crud_service',
		'global'						: 'core/services/global',
		'formatter'						: 'core/services/formatter',
		'authentication_service'		: 'core/services/auth_service',
		'unsavedChanges'				: 'core/services/unsaved_changes',
		'focusManager'					: 'core/services/focus_directive',

		/*                  ui-components                     */
		'EntryForm'						: 'ui-components/form/entry-form/entry-form_directive',

		'FormControlWrapper'			: 'ui-components/form/controls/core/form-control-wrapper/form-control-wrapper_directive',
		'iOSKeyboard'					: 'ui-components/form/controls/core/iOS-keyboard/iOS-keyboard_directive',

		'InputRange'					: 'ui-components/form/controls/simple/input-range/input-range_directive',
		'InputSelect'					: 'ui-components/form/controls/simple/input-select/input-select_directive',
		'InputText'						: 'ui-components/form/controls/simple/input-text/input-text_directive',
		'InputFile'						: 'ui-components/form/controls/simple/input-file/input-file_directive',
		'InputNumber'					: 'ui-components/form/controls/simple/input-number/input-number_directive',
		'InputGroupCheckbox'			: 'ui-components/form/controls/simple/input-group-checkbox/input-group-checkbox_directive',
		'InputGroupRadio'				: 'ui-components/form/controls/simple/input-group-radio/input-group-radio_directive',
		'accessibleDatePickerServices'	: 'ui-components/form/controls/simple/accessibledatepicker/accessibledatepicker_directive',
		'accessibleTimePickerServices'	: 'ui-components/form/controls/simple/accessibletimepicker/accessibletimepicker_directive',

		'DateControls'					: 'ui-components/form/controls/composite/input-date-picker/date-controls_directive',
		'TimeControls'					: 'ui-components/form/controls/composite/input-time-picker/time-controls_directive',
		'InputDateTime'					: 'ui-components/form/controls/composite/input-date-time/input-date-time_directive',
		'MultiTime'						: 'ui-components/form/controls/composite/input-multi-time-picker/multi-time_directive',
		'MultiPhone'					: 'ui-components/form/controls/composite/input-multi-phone/multi-phone_directive',

		'UserInputPattern'				: 'ui-components/form/validation/user-input-pattern/user-input-pattern_directive',
		'ValidationSummary'				: 'ui-components/form/validation/validation-summary/validation-summary',
		'ErrorHandling'					: 'ui-components/form/validation/validation-summary/error-handling_directive',
		'RequiredField'					: 'ui-components/form/validation/required-field-indicator/required-field-indicator_directive',

		'modalService'					: 'ui-components/modals/helper/modal_service',
		'HelpController'				: 'ui-components/modals/help/help_controller',
		'AboutController'				: 'ui-components/modals/about/about_controller',
        'ClearController'				: 'ui-components/modals/clearData/clear_data_controller',

		'FilterButton'					: 'ui-components/filter-button/filter-button_directive',
		'FilterWrapper'					: 'ui-components/filter/filter-wrapper_directive',
		'StatusFilter'					: 'ui-components/filter/status-filter/status-filter_directive',

		'AriaHidden'					: 'ui-components/accessibility/aria-hidden/aria-hidden_directive',

		'aDirecitve'					: 'ui-components/html-extensions/a_directive',
		'iDirecitve'					: 'ui-components/html-extensions/i_directive',

		'clamp'							: 'ui-components/line-clamp/clamp_directive',

		'DataTableDirective'			: 'ui-components/table/table_directive',

		'BackButton'					: 'ui-components/back-button/back-button_directive',

		'AccessibleAccordion'			: 'ui-components/accordion/accessibleaccordion_directive'
	},

	shim: {
		'jQuery'				: {exports: '$'},
		'angular'				: {deps: ['jQuery'], 'exports': 'angular'},
		'angularRoute'			: ['angular'],
		'angularCookies'		: ['angular'],
		'angularAnimate'		: ['angular'],
		'angularSanitize'		: ['angular'],
		'angularResource'		: ['angular'],
		'angularUiRouter'		: ['angular'],
		'angularUiBootstrap'	: ['angular'],
		'angularBusy'			: ['angular'],
		'app'					: { deps: ['angular'], exports: 'app' },
		'Modernizr'				: { exports: 'Modernizr' },
		'main_controller'		: {
									deps: ['app'],
									exports: 'main_controller'
								},
		'eula_service': 			{
									deps: ['app', 'jQuery'],
									exports: 'service'
								},
		'eula_controller': 		{
									deps: ['app', 'eula_service'],
									exports: 'eula_controller'
								},
		'angularMocks': 		{
									deps: ['angular'],
									'exports': 'angular.mock'
								}
	},
 map: {
    "*": {
        "jquery": "jQuery"
    }
   },
	// ask Require.js to load these files (all our tests)
	deps: tests,

	// start test run, once Require.js is done
	callback: window.__karma__.start
});